package net.wanji.databus.dao.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import net.wanji.databus.dto.MetricHistDTO;
import net.wanji.databus.po.CrossLaneDataHistPO;
import net.wanji.databus.po.CrossLaneDataHistPOExt;
import net.wanji.databus.vo.CrossLaneDataHistVOExt;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

/**
 * @author duanruiming
 * @date 2023/03/10 21:11
 */
@Mapper
public interface CrossLaneDataHistMapper extends BaseMapper<CrossLaneDataHistPO> {
    void insertBatch(@Param("list") List<CrossLaneDataHistPO> list);
    void deleteBatch(@Param("list") Collection<String> crossIds);
    List<MetricHistDTO> selectMetricHistDTO(String crossId, int startStamp, int endStamp, String laneId);
    List<CrossLaneDataHistPOExt> selectByCrossIdAndDir(String crossId, Integer dir, int endTimeStamp, int startTimeStamp);

    List<CrossLaneDataHistPOExt> selectByCrossId(String crossId, int endTimeStamp, int startTimeStamp);

    Integer selectCountByCrossIdAndTimeSpan(String crossId, int startTimeStamp, int endTimeStamp);

    List<CrossLaneDataHistPOExt> selectByCrossIdAndTimeSpan(String crossId, int startTimeStamp, int endTimeStamp);

    /**
     * 车道级查询
     * @param crossId 路口id
     * @param startStamp
     * @param endStamp
     * @param ids 车道id集合
     * @return
     */
    List<CrossLaneDataHistVOExt> selectByCrossIdAndTimeIds(String crossId, int startStamp, int endStamp, String granularity, List<String> ids);
}
